/* YC 0.2: Fri Dec 10 11:49:52 CET 1999 */
/* Module-P: ESFormat-ItemOrder */

#ifndef zes_order_P_H
#define zes_order_P_H

#include <yaz/zes-order.h>
#ifdef __cplusplus
extern "C" {
#endif
struct Z_IORequest {
	Z_IOOriginPartToKeep *toKeep; /* OPT */
	Z_IOOriginPartNotToKeep *notToKeep;
};

struct Z_IOTaskPackage {
	Z_IOOriginPartToKeep *originPart; /* OPT */
	Z_IOTargetPart *targetPart;
};

struct Z_IOItemOrder {
	int which;
	union {
		Z_IORequest *esRequest;
		Z_IOTaskPackage *taskPackage;
#define Z_IOItemOrder_esRequest 1
#define Z_IOItemOrder_taskPackage 2
	} u;
};

struct Z_IOContact {
	Z_InternationalString *name; /* OPT */
	Z_InternationalString *phone; /* OPT */
	Z_InternationalString *email; /* OPT */
};

struct Z_IOBilling {
	int which;
	union {
		Odr_null *billInvoice;
		Odr_null *prepay;
		Odr_null *depositAccount;
		Z_IOCreditCardInfo *creditCard;
		Odr_null *cardInfoPreviouslySupplied;
		Odr_null *privateKnown;
		Z_External *privateNotKnown;
#define Z_IOBilling_billInvoice 1
#define Z_IOBilling_prepay 2
#define Z_IOBilling_depositAccount 3
#define Z_IOBilling_creditCard 4
#define Z_IOBilling_cardInfoPreviouslySupplied 5
#define Z_IOBilling_privateKnown 6
#define Z_IOBilling_privateNotKnown 7
	} u;
	Z_InternationalString *customerReference; /* OPT */
	Z_InternationalString *customerPONumber; /* OPT */
};

struct Z_IOOriginPartToKeep {
	Z_External *supplDescription; /* OPT */
	Z_IOContact *contact; /* OPT */
	Z_IOBilling *addlBilling; /* OPT */
};

struct Z_IOCreditCardInfo {
	Z_InternationalString *nameOnCard;
	Z_InternationalString *expirationDate;
	Z_InternationalString *cardNumber;
};

struct Z_IOResultSetItem {
	Z_InternationalString *resultSetId;
	int *item;
};

struct Z_IOOriginPartNotToKeep {
	Z_IOResultSetItem *resultSetItem; /* OPT */
	Z_External *itemRequest; /* OPT */
};

struct Z_IOTargetPart {
	Z_External *itemRequest; /* OPT */
	Z_External *statusOrErrorReport; /* OPT */
#define Z_IOTargetPart_notReceived 1
#define Z_IOTargetPart_loanQueue 2
#define Z_IOTargetPart_forwarded 3
#define Z_IOTargetPart_unfilledCopyright 4
#define Z_IOTargetPart_filledCopyright 5
	int *auxiliaryStatus; /* OPT */
};

#ifdef __cplusplus
}
#endif
#endif
