/* YC 0.2 Fri Dec 10 11:49:52 CET 1999 */
/* Module-C: ResourceReport-Format-Universe-1 */

#include <yaz/z-univ-p.h>

int z_UniverseReportHits (ODR o, Z_UniverseReportHits **p, int opt, const char *name)
{
	if (!odr_sequence_begin (o, p, sizeof(**p), name))
		return opt && odr_ok (o);
	return
		z_StringOrNumeric(o, &(*p)->database, 0, "database") &&
		z_StringOrNumeric(o, &(*p)->hits, 0, "hits") &&
		odr_sequence_end (o);
}

int z_UniverseReportDuplicate (ODR o, Z_UniverseReportDuplicate **p, int opt, const char *name)
{
	if (!odr_sequence_begin (o, p, sizeof(**p), name))
		return opt && odr_ok (o);
	return
		z_StringOrNumeric(o, &(*p)->hitno, 0, "hitno") &&
		odr_sequence_end (o);
}

int z_UniverseReport (ODR o, Z_UniverseReport **p, int opt, const char *name)
{
	static Odr_arm arm[] = {
		{ODR_IMPLICIT, ODR_CONTEXT, 0, Z_UniverseReport_databaseHits,
		(Odr_fun) z_UniverseReportHits, "databaseHits"},
		{ODR_IMPLICIT, ODR_CONTEXT, 1, Z_UniverseReport_duplicate,
		(Odr_fun) z_UniverseReportDuplicate, "duplicate"},
		{-1, -1, -1, -1, (Odr_fun) 0, 0}
	};
	if (!odr_sequence_begin (o, p, sizeof(**p), name))
		return opt && odr_ok (o);
	return
		odr_integer(o, &(*p)->totalHits, 0, "totalHits") &&
		odr_choice (o, arm, &(*p)->u, &(*p)->which, 0) &&
		odr_sequence_end (o);
}
